from five import grok
from zope import schema

from plone.directives import form, dexterity

from plone.app.textfield import RichText
from plone.namedfile.field import NamedImage

from ngren.theme import _

from plone.dexterity.content import Item, Container

from plone.app.layout.viewlets.common import ViewletBase
from Products.Five.browser.pagetemplatefile import ViewPageTemplateFile
from Products.CMFCore.utils import getToolByName
from frontpagecontent import IFrontpageContent
from zope.app.component.hooks import getSite


class ISlide(form.Schema):
    """A Slide element which will be displayed in the Slide Show
    """
    title = schema.TextLine( title=_(u"Title"), required=True ) 
    picture = NamedImage(title=_(u"Slide Show Image"), description=_(u"Please upload an image"), required=False)
    text = RichText( title=_(u"Text"), required=False)
    link = schema.TextLine(title=_(u"Link"), required=False)

class Slide( Item ):
    grok.implements(ISlide)

    def __init__(self, *args):
        super(Slide, self).__init__(*args)
        self.exclude_from_nav = True        

		
		
		
class SlideViewlet(ViewletBase):
	index = ViewPageTemplateFile('templates/slideviewlet.pt')
	
	def update(self):
		self.slides = []
		portal = getSite()
		catalog = getToolByName(portal, "portal_catalog")
		path = "/".join(portal.getPhysicalPath())
		frontpagecontents = catalog.searchResults(
			object_provides=IFrontpageContent.__identifier__,
			path={'query':path, 'depth':1},
			sort_on='getObjPositionInParent')

		if len(frontpagecontents) > 0:
			path2 = "/".join(frontpagecontents[0].getObject().getPhysicalPath())
			slides = catalog.searchResults(
				object_provides=ISlide.__identifier__,
				path={'query':path2, 'depth':1},
				sort_on='getObjPositionInParent',
				review_state='published')
		
			self.slides = [i.getObject() for i in slides]
			
